ALTER TABLE Users
    ADD Birthday DATE NULL AFTER MessageCount;



ALTER TABLE UsersHistory
    ADD Birthday DATE NULL AFTER MessageCount;


ALTER TABLE `Users`
    CHANGE `CreatedAt` `CreatedAt` DATETIME(6) NULL DEFAULT CURRENT_TIMESTAMP(6);;

ALTER TABLE `Users`
    CHANGE `LastModifiedAt` `LastModifiedAt` DATETIME(6) NULL DEFAULT CURRENT_TIMESTAMP(6) ON UPDATE CURRENT_TIMESTAMP(6);;

DROP TRIGGER IF EXISTS `TR_UsersUpdate`;;

CREATE TRIGGER `TR_UsersUpdate`
    AFTER UPDATE
    ON `Users`
    FOR EACH ROW
BEGIN
    INSERT INTO `UsersHistory` (`Id`, `DiscordId`, `XP`, `ReactionCount`, `MessageCount`, `Birthday`, `ServerId`,
                                `DateFrom`, `DateTo`)
    VALUES (OLD.UserId, OLD.DiscordId, OLD.XP, OLD.ReactionCount, OLD.MessageCount, OLD.Birthday, OLD.ServerId,
            OLD.LastModifiedAt, CURRENT_TIMESTAMP(6));
END;;

DROP TRIGGER IF EXISTS `TR_UsersDelete`;;

CREATE TRIGGER `TR_UsersDelete`
    AFTER DELETE
    ON `Users`
    FOR EACH ROW
BEGIN
    INSERT INTO `UsersHistory` (`Id`, `DiscordId`, `XP`, `ReactionCount`, `MessageCount`, `Birthday`, `ServerId`,
                                `Deleted`, `DateFrom`, `DateTo`)
    VALUES (OLD.UserId, OLD.DiscordId, OLD.XP, OLD.ReactionCount, OLD.MessageCount, OLD.Birthday, OLD.ServerId, TRUE,
            OLD.LastModifiedAt, CURRENT_TIMESTAMP(6));
END;;


ALTER TABLE CFG_Server
    ADD XpForBirthday BIGINT(20) NOT NULL DEFAULT 0 AFTER XpPerAchievement;



ALTER TABLE CFG_ServerHistory
    ADD XpForBirthday BIGINT(20) NOT NULL DEFAULT 0 AFTER XpPerAchievement;

DROP TRIGGER IF EXISTS `TR_CFG_ServerUpdate`;;

CREATE TRIGGER `TR_CFG_ServerUpdate`
    AFTER UPDATE
    ON `CFG_Server`
    FOR EACH ROW
BEGIN
    INSERT INTO `CFG_ServerHistory` (`Id`,
                                     `MessageDeleteTimer`,
                                     `NotificationChatId`,
                                     `MaxVoiceStateHours`,
                                     `XpPerMessage`,
                                     `XpPerReaction`,
                                     `MaxMessageXpPerHour`,
                                     `XpPerOntimeHour`,
                                     `XpPerEventParticipation`,
                                     `XpPerAchievement`,
                                     `AFKCommandChannelId`,
                                     `HelpVoiceChannelId`,
                                     `TeamChannelId`,
                                     `LoginMessageChannelId`,
                                     `DefaultRoleId`,
                                     `ShortRoleNameSetOnlyHighest`,
                                     `FeatureFlags`,
                                     `ServerId`,
                                     `DateFrom`,
                                     `DateTo`)
    VALUES (OLD.Id,
            OLD.MessageDeleteTimer,
            OLD.NotificationChatId,
            OLD.MaxVoiceStateHours,
            OLD.XpPerMessage,
            OLD.XpPerReaction,
            OLD.MaxMessageXpPerHour,
            OLD.XpPerOntimeHour,
            OLD.XpPerEventParticipation,
            OLD.XpPerAchievement,
            OLD.AFKCommandChannelId,
            OLD.HelpVoiceChannelId,
            OLD.TeamChannelId,
            OLD.LoginMessageChannelId,
            OLD.DefaultRoleId,
            OLD.ShortRoleNameSetOnlyHighest,
            OLD.FeatureFlags,
            OLD.ServerId,
            OLD.LastModifiedAt,
            CURRENT_TIMESTAMP(6));
END;;

DROP TRIGGER IF EXISTS `TR_CFG_ServerDelete`;;

CREATE TRIGGER `TR_CFG_ServerDelete`
    AFTER DELETE
    ON `CFG_Server`
    FOR EACH ROW
BEGIN
    INSERT INTO `CFG_ServerHistory` (`Id`,
                                     `MessageDeleteTimer`,
                                     `NotificationChatId`,
                                     `MaxVoiceStateHours`,
                                     `XpPerMessage`,
                                     `XpPerReaction`,
                                     `MaxMessageXpPerHour`,
                                     `XpPerOntimeHour`,
                                     `XpPerEventParticipation`,
                                     `XpPerAchievement`,
                                     `AFKCommandChannelId`,
                                     `HelpVoiceChannelId`,
                                     `TeamChannelId`,
                                     `LoginMessageChannelId`,
                                     `DefaultRoleId`,
                                     `ShortRoleNameSetOnlyHighest`,
                                     `ServerId`,
                                     `FeatureFlags`,
                                     `Deleted`,
                                     `DateFrom`,
                                     `DateTo`)
    VALUES (OLD.Id,
            OLD.MessageDeleteTimer,
            OLD.NotificationChatId,
            OLD.MaxVoiceStateHours,
            OLD.XpPerMessage,
            OLD.XpPerReaction,
            OLD.MaxMessageXpPerHour,
            OLD.XpPerOntimeHour,
            OLD.XpPerEventParticipation,
            OLD.XpPerAchievement,
            OLD.AFKCommandChannelId,
            OLD.HelpVoiceChannelId,
            OLD.TeamChannelId,
            OLD.LoginMessageChannelId,
            OLD.DefaultRoleId,
            OLD.ShortRoleNameSetOnlyHighest,
            OLD.FeatureFlags,
            OLD.ServerId,
            TRUE,
            OLD.LastModifiedAt,
            CURRENT_TIMESTAMP(6));
END;;

